/*****************************************************************************
 *               Copyright (C) 2011, Huawei Tech. Co., Ltd.
 *                           ALL RIGHTS RESERVED
******************************************************************************/
/**\file dnscmsapi.h
  *dnscms api \n
  *DNSCMSĳʼDNSRedirectResidentĹ
  *\copyright 2007-2020Ϊ޹˾
  *\author t00189036
  *\date  2011-12-20
*/
#ifndef __DNSCMS_API_H__
#define __DNSCMS_API_H__

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "msgapi.h"
#ifdef SUPPORT_ATP_TR181
#include "dnscmsdb.h"
#endif


#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#define DNS_FILE_RESOVL   "/var/dns/resolv.conf"
//!\brief DNSCMSĴ
/*!
 *These errors are reserved for dnscms only
 */
typedef enum tagDNSCMS_RET_CODE_EN
{    
    DNSCMS_RET_PARA_ERR        = ATP_MNT_ERR_CODE_DEF(ATP_TEAM_CMS, ATP_MODULE_DNSCMS),/*!< δ */
    DNSCMS_RET_MEM_ERR,/*!< ڴ */
    DNSCMS_RET_NOT_SPPORTED,/*!< ֵ֧ */
    DNSCMS_RET_WAN_ERR,/*!< WANйصĴ  */
} DNSCMS_RET_CODE_EN;

#ifdef ATP_DEBUG
#define ATP_DNSCMS_DEBUG(format, args...)       {printf("FILE: %s FUNC: %s LINE: %d: ", __FILE__,__func__, __LINE__);printf(format, ##args);}
#else
#define ATP_DNSCMS_DEBUG(x...)
#endif

/*****************************************************************************
*                               Init Module
******************************************************************************/
/*!
  \brief DNSCMSʼ
  \param[in] 
  \return ATP_MSG_RET͵ĴDNSCMS_RETĴ
  \retval DNSCMS_RET_PARA_ERR Ϊ
*/
#ifdef SUPPORT_ATP_TR181
VOS_UINT32 ATP_DNSCMS_Init();
#else
VOS_UINT32 ATP_DNSCMS_Init(VOS_VOID *pvNotifier, VOS_VOID *pvNotifyHook);
#endif


/*****************************************************************************
*                               Redirect Module
******************************************************************************/
/*!
  \brief ضDNSģ
  \param[in]  *pstRedirect:ضϢ
  \return ATP_MSG_RET͵ĴDNSCMS_RETĴ
  \retval DNSCMS_RET_PARA_ERR Ϊ
*/
VOS_UINT32 ATP_DNSCMS_AppendRedirect(const ATP_DNS_REDIRECT_MSG_ST *pstRedirect);

/*!
  \brief DNSģɾض
  \param[in]  *pstRedirect: ضϢ
  \return ATP_MSG_RET͵ĴDNSCMS_RETĴ
  \retval DNSCMS_RET_PARA_ERR Ϊ
*/
VOS_UINT32 ATP_DNSCMS_DeleteRedirect(const ATP_DNS_REDIRECT_MSG_ST *pstRedirect);

/*!
  \brief DNSģض
  \return ATP_MSG_RET͵Ĵ
*/
VOS_UINT32 ATP_DNSCMS_FlushRedirect();


/*****************************************************************************
*                               Resident Module
******************************************************************************/
/*!
  \brief ResidentDNSģ
  \param[in]  *pstResident: ResidentϢ
  \return ATP_MSG_RET͵ĴDNSCMS_RETĴ
  \retval DNSCMS_RET_PARA_ERR Ϊ
*/
VOS_UINT32 ATP_DNSCMS_AppendResident(const ATP_DNS_RESIDENT_MSG_ST *pstResident);

/*!
  \brief DNSģɾResident
  \param[in]  *pstResident: ResidentϢ
  \return ATP_MSG_RET͵ĴDNSCMS_RETĴ
  \retval DNSCMS_RET_PARA_ERR Ϊ
*/
VOS_UINT32 ATP_DNSCMS_DeleteResident(const ATP_DNS_RESIDENT_MSG_ST *pstResident);

/*!
  \brief DNSģض
  \return ATP_MSG_RET͵Ĵ
*/
VOS_UINT32 ATP_DNSCMS_FlushResident();

/*!
  \brief dnsʱСTTL
  \return ATP_MSG_RET͵Ĵ
*/
VOS_UINT32 ATP_DNSCMS_SetMinTTL(VOS_UINT32 ulMinTTL);

/*!
  \brief DNSģһ˹
  \param[in]  *pstFilter: ˹Ϣ
  \return ATP_MSG_RET͵ĴDNSCMS_RETĴ
  \retval DNSCMS_RET_PARA_ERR Ϊ
*/
VOS_UINT32 ATP_DNSCMS_AppendFilter(const ATP_DNS_FILTER_MSG_ST *pstFilter);

/*!
  \brief DNSģɾһ˹
  \param[in]  *pstFilter: ˹Ϣ
  \return ATP_MSG_RET͵ĴDNSCMS_RETĴ
  \retval DNSCMS_RET_PARA_ERR Ϊ
*/

VOS_UINT32 ATP_DNSCMS_DeleteFilter(const ATP_DNS_FILTER_MSG_ST *pstFilter);

/*!
  \brief DNSģеĹ˹
  \return ATP_MSG_RET͵Ĵ
*/
VOS_UINT32 ATP_DNSCMS_FlushFilter();

#if (defined(SUPPORT_ATP_DNS_SERVERPRIORITY_W724V)||defined(SUPPORT_ATP_IPV6_PPP_DIAL_ON_DEMAND))		
/*!
  \brief W724v԰貦ŵĶ
  \return ATP_MSG_RET͵Ĵ
*/
VOS_UINT32 ATP_DNSCMS_PPPTrigerChange2OnDemand();
#endif

#ifdef __cplusplus
#if __cplusplus
}
#endif /* __cpluscplus */
#endif /* __cpluscplus */


#endif  /* __DNSCMS_API_H__ */

